package io.tswf.minecraft.blockventure.core.transmutation

import com.sun.jdi.LocalVariable
import groovy.transform.CompileStatic
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.AtMethodCall
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ClassReference
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Constant
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.LocalVariableValue
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.MethodDescription
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.ReturningConstantIfTrue
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Self
import io.tswf.groovy.bettergroovy.asm.transmutation.annotation.Transmute
import io.tswf.groovy.bettergroovy.asm.transmutation.injection.points.MethodCallInsnType
import io.tswf.groovy.bettergroovy.asm.transmutation.meta.MissingTargetStrategy
import io.tswf.minecraft.blockventure.core.expansion.IMetadataSensitiveIngredient
import net.minecraft.item.Item
import net.minecraft.item.ItemStack
import net.minecraft.recipe.Ingredient

import javax.annotation.Nullable

@CompileStatic
class TransmutationRecipeIngredient {

    @Transmute(
            targetClass = @ClassReference(Ingredient),
            targetMethod = @MethodDescription(name = "test", parameterTypeClasses = ItemStack, returnType = @ClassReference(descriptor = "Z")),
            onMissing = MissingTargetStrategy.THROW
    )
    @ReturningConstantIfTrue(@Constant(booleanValue = false))
    @AtMethodCall(
            owner = @ClassReference(ItemStack),
            method = @MethodDescription(name = "isOf", parameterTypeClasses = Item, returnType = @ClassReference(descriptor = "Z")),
            callType = MethodCallInsnType.VIRTUAL
    )
    static boolean test(
            ItemStack stackToCheck,

            @Self
            Ingredient self,

            @LocalVariableValue(index = 5, type = @ClassReference(ItemStack))
            ItemStack matchingStack
    ) {
        if (self instanceof IMetadataSensitiveIngredient) {
            if (self.metadataSensitive && matchingStack.damage != Short.MAX_VALUE && stackToCheck.damage != matchingStack.damage) {
                return true
            }

        }

        return false
    }

}
